#include <stdio.h>
#include <stdlib.h>
#include <mcheck.h>
#include <err.h>
#include "./lib/cr.h"
#include "./lib/cw.h"

int main(void){
  cr c1;
  cw c2;
  parStr e;
/*   char *it, *dsc; */

#ifndef NDEBUG
  mtrace ();
#endif

  c1 = cr_create("pru.txt");

  if (c1 == NULL)
    errx(EXIT_FAILURE, "Error al crear cinta de lectura"
	 ", archivo %s, linea %i", __FILE__, __LINE__);
  
  c2 = cw_create("pruw.txt");
  if (c2 == NULL){
    c1 = cr_destroy(c1);
    errx(EXIT_FAILURE, "Error al crear cinta de escritura" 
	 ", archivo %s, linea %i", __FILE__, __LINE__);
  }
    
  c1 = cr_arr(c1);
  if (c1 == NULL){
    c2 = cw_destroy(c2);
    errx(EXIT_FAILURE, "Error al arrancar cinta de lectura"
	 ", archivo %s, linea %i", __FILE__, __LINE__);
  }

  c2 = cw_arr(c2);
  if (c2 == NULL){
    c1 = cr_destroy(c1);
    errx(EXIT_FAILURE, "Error al arrancar cinta de escritura"
	 ", archivo %s, linea %i", __FILE__, __LINE__);
  }

  while (c1 != NULL && !cr_fin(c1) && c2 != NULL){

    e = cr_elecor(c1);

    if (e == NULL) 
      errx(EXIT_FAILURE, "No se devolvio elecorr"
	   ", archivo %s, linea %i", __FILE__, __LINE__);
    
/*     it  = parStr_fst(e); */
/*     dsc = parStr_snd(e); */

/*     if (it == NULL || dsc == NULL) { */
/*       errx(EXIT_FAILURE, "no se devolvio algun string" */
/* 	   ", archivo %s, linea %i", __FILE__, __LINE__); */

/*     printf("%s: %s\n", it, dsc); */

/*        free(it); free(dsc); */
 
      
    c2 = cw_insert(c2, e);

    e = parStr_destroy(e);

    cr_av(c1);
  }
  
  if (c1==NULL)
      errx(EXIT_FAILURE, "No se pudo avanzar"
	   ", archivo %s, linea %i", __FILE__, __LINE__);

  if (c2==NULL)
      errx(EXIT_FAILURE, "No se pudo insertar"
	   ", archivo %s, linea %i", __FILE__, __LINE__);

  c1 = cr_destroy(c1);
  c2 = cw_destroy(c2);

  return EXIT_SUCCESS;
}
